---
sudo: required
dist: bullseye 

language: python
python:
  - "3.7"
  - "3.8"
  - "3.9"

env:
  - ANSIBLE_VERSION=latest
  - ANSIBLE_VERSION=2.12.0
  - ANSIBLE_VERSION=2.11.7
  - ANSIBLE_VERSION=2.10.16

branches:
  only:
    - main 

before_install:
  - sudo apt-get update -qq

  # Remove fail2ban
  - sudo apt-get remove --purge --yes fail2ban

install:
  # Install Ansible.
  - if [ "$ANSIBLE_VERSION" = "latest" ]; then pip install ansible; else pip install ansible==$ANSIBLE_VERSION; fi
  - if [ "$ANSIBLE_VERSION" = "latest" ]; then pip install ansible-lint; fi

script:
  # Check the role/playbook's syntax.
  - ansible-playbook -i tests/inventory tests/test.yml --syntax-check

  # Install docker role for dockerhost
  - ansible-galaxy install -r requirements.yml

  # Run the role/playbook with ansible-playbook.
  - ansible-playbook -i tests/inventory tests/test.yml -vvvv

  # Run the role/playbook again, checking to make sure it's idempotent.
  - >
    ansible-playbook -i tests/inventory tests/test.yml
    | grep -q 'changed=0.*failed=0'
    && (echo 'Idempotence test: pass' && exit 0)
    || (echo 'Idempotence test: fail' && exit 1)

  - if [ "$ANSIBLE_VERSION" = "latest" ]; then ansible-lint tests/test.yml; fi

after_script:
    - bash ./telegram_notification.sh

notifications:
  email:
    - mail@therojam.tech
    - admin.amueller@gmail.com 
  webhooks: https://galaxy.ansible.com/api/v1/notifications/
